<template>
  <nav class="navbar navbar-light bg-light">
    <div class="container-fluid">
      <h1 class="headerNav">Double Calculator</h1>
    </div>
  </nav>
  <!-- -------------------------------  HTML Calculator A -------------------------------------------- -->
  <div class="row content">
    <div class="col">
      <h1 class="header">Calculator A</h1>
      <div class="card">
        <div class="container">
          <div class="container">
            <h2 class="current" data-operand-current>
              {{ currentScreenText_A }}
            </h2>
            <hr />
            <h5 class="previous" data-operand-previous>
              {{ previousScreenText_A }}
            </h5>
          </div>

          <div class="row r1">
            <div class="col-sm-2 c1">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="btC" data-all-clear @click="clear_A()">
                    C
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt7" data-number @click="calculator_A('7')">
                    7
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c2">
              <div class="row r12">
                <div class="col-2 col-sm-12">
                  <button class="btX" data-operation @click="calculator_A('x')">
                    x
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt8" data-number @click="calculator_A('8')">
                    8
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c3">
              <div class="row r13">
                <div class="col-2 col-sm-12">
                  <button
                    class="btMinus"
                    data-operation
                    @click="calculator_A('-')"
                  >
                    -
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt9" data-number @click="calculator_A('9')">
                    9
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c4">
              <button class="btPlus" data-operation @click="calculator_A('+')">
                +
              </button>
            </div>
          </div>

          <div class="row r2">
            <div class="col-sm-2 c5">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt4" data-number @click="calculator_A('4')">
                    4
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt1" data-number @click="calculator_A('1')">
                    1
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt0" data-number @click="calculator_A('0')">
                    0
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c6">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt5" data-number @click="calculator_A('5')">
                    5
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt2" data-number @click="calculator_A('2')">
                    2
                  </button>
                </div>
                <!-- <div class="col-2 col-sm-12"><button class="bt0">0</button></div> -->
              </div>
            </div>
            <div class="col-sm-2 c7">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt6" data-number @click="calculator_A('6')">
                    6
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt3" data-number @click="calculator_A('3')">
                    3
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button
                    class="btPoint"
                    data-number
                    @click="calculator_A('.')"
                  >
                    .
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c8">
              <button class="btEqual" data-equals @click="computation_A()">
                =
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- -------------------------------  HTML Calculator B -------------------------------------------- -->
    <div class="col">
      <h1 class="header">Calculator B</h1>
      <div class="card">
        <div class="container">
          <div class="container">
            <h2 class="current" data-operand-current>
              {{ currentScreenText_B }}
            </h2>
            <hr />
            <h5 class="previous" data-operand-previous>
              {{ previousScreenText_B }}
            </h5>
          </div>

          <div class="row r1">
            <div class="col-sm-2 c1">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="btC" data-all-clear @click="clear_B()">
                    C
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt7" data-number @click="calculator_B('7')">
                    7
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c2">
              <div class="row r12">
                <div class="col-2 col-sm-12">
                  <button class="btX" data-operation @click="calculator_B('x')">
                    x
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt8" data-number @click="calculator_B('8')">
                    8
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c3">
              <div class="row r13">
                <div class="col-2 col-sm-12">
                  <button
                    class="btMinus"
                    data-operation
                    @click="calculator_B('-')"
                  >
                    -
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt9" data-number @click="calculator_B('9')">
                    9
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c4">
              <button class="btPlus" data-operation @click="calculator_B('+')">
                +
              </button>
            </div>
          </div>

          <div class="row r2">
            <div class="col-sm-2 c5">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt4" data-number @click="calculator_B('4')">
                    4
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt1" data-number @click="calculator_B('1')">
                    1
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt0" data-number @click="calculator_B('0')">
                    0
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c6">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt5" data-number @click="calculator_B('5')">
                    5
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt2" data-number @click="calculator_B('2')">
                    2
                  </button>
                </div>
                <!-- <div class="col-2 col-sm-12"><button class="bt0">0</button></div> -->
              </div>
            </div>
            <div class="col-sm-2 c7">
              <div class="row">
                <div class="col-2 col-sm-12">
                  <button class="bt6" data-number @click="calculator_B('6')">
                    6
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button class="bt3" data-number @click="calculator_B('3')">
                    3
                  </button>
                </div>
                <div class="col-2 col-sm-12">
                  <button
                    class="btPoint"
                    data-number
                    @click="calculator_B('.')"
                  >
                    .
                  </button>
                </div>
              </div>
            </div>
            <div class="col-sm-2 c8">
              <button class="btEqual" data-equals @click="computation_B()">
                =
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- -------------------------------  HTML History -------------------------------------------- -->
    <div class="col">
      <div class="row">
        <div class="col-2">
          <h1 class="headerHis">Results</h1>
        </div>
        <div class="col-6">
          <input
            class="select1"
            placeholder="Search by result, date"
            v-model="search"
          />
        </div>
        <div class="col-3">
          <select
            name="calculators"
            id="calculators"
            class="select2"
            @change="onChange($event)"
            v-model="key"
          >
            <option value="All">All</option>
            <option value="Calculator_A">Calculator A</option>
            <option value="Calculator_B">Calculator B</option>
          </select>
        </div>
      </div>

      <div class="card cardHis">
        <br />
        <div v-if="hisResult.length !== 0">
          <div
            class="container"
            v-for="data in filterHistory"
            v-bind:key="data"
          >
            <div
              v-if="selectCal == 'Calculator_A' && data.name == 'Calculator A'"
            >
              <div class="row">
                <div class="col-6">
                  <header class="calName">{{ data.name }}</header>
                </div>
                <div class="col-6">
                  <h5 class="hisDate">{{ data.date }}</h5>
                </div>
              </div>
              <h2 class="hisCurrent">{{ data.result }}</h2>
              <hr class="hisLine" />
              <h5 class="previous">{{ data.previousScreen }}</h5>
            </div>

            <div
              v-if="selectCal == 'Calculator_B' && data.name == 'Calculator B'"
            >
              <div class="row">
                <div class="col-6">
                  <header class="calName">{{ data.name }}</header>
                </div>
                <div class="col-6">
                  <h5 class="hisDate">{{ data.date }}</h5>
                </div>
              </div>
              <h2 class="hisCurrent">{{ data.result }}</h2>
              <hr class="hisLine" />
              <h5 class="previous">{{ data.previousScreen }}</h5>
            </div>

            <div v-if="selectCal == 'All'">
              <div class="row">
                <div class="col-6">
                  <header class="calName">{{ data.name }}</header>
                </div>
                <div class="col-6">
                  <h5 class="hisDate">{{ data.date }}</h5>
                </div>
              </div>
              <h2 class="hisCurrent">{{ data.result }}</h2>
              <hr class="hisLine" />
              <h5 class="previous">{{ data.previousScreen }}</h5>
            </div>
          </div>
          <div class="position-absolute bottom-0 end-0">
            <button class="hisClear" @click="clear_history()">Clear</button>
          </div>
        </div>
        <div v-else>
          <div class="container">
            <header class="calName">There's no history yet</header>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: "Calculator",
  data() {
    return {
      currentScreenText_A: "0",
      previousScreenText_A: "0",
      value_A: "",
      current_A: "",
      previous_A: "",
      new_A: "",
      arrA: {},
      pointStatus: false,

      currentScreenText_B: "0",
      previousScreenText_B: "0",
      value_B: "",
      current_B: "",
      previous_B: "",
      new_B: "",
      arrB: [],

      hisResult: [],
      allHistory: [],
      date: new Date(),
      key: "All",
      selectCal: "All",
      search: "",
    };
  },
  computed: {
    filterHistory() {
      // if (JSON.parse(localStorage.getItem('historyList'))) {
      //   this.hisResult = JSON.parse(localStorage.getItem('historyList'));
      // }
      return this.hisResult.filter((history) => {
        return (
          history.result.toString().match(this.search) ||
          history.date.toString().match(this.search)
        );
      });
    },
  },
  methods: {
    // -------------------------------  Method Calculator A --------------------------------------------
    calculator_A(value) {
      if (this.previousScreenText_A == "0") {
        if (value == ".") {
          this.previousScreenText_A += value;
          this.previous_A = "0" + value;
        } else {
          this.previousScreenText_A = value;
          this.previous_A = value;
        }
      } else {
        if (
          (this.new_A[1] == "+" ||
            this.new_A[1] == "-" ||
            this.new_A[1] == "x" ||
            this.new_A[1] == ".") &&
          (value == "+" || value == "-" || value == "x" || value == ".")
        ) {
          this.previousScreenText_A =
            this.previousScreenText_A.slice(0, -1) + value;
          if (this.new_A[1] == "+") {
            this.previous_A = this.previous_A.slice(0, -3);
            if (value == "+") {
              this.value_A = "%2B";
              this.previous_A = this.previous_A + this.value_A;
            } else if (value == "x") {
              this.value_A = "*";
              this.previous_A = this.previous_A + this.value_A;
            } else {
              this.previous_A = this.previous_A + value;
            }
          }
          if (this.new_A[1] == "-") {
            this.previous_A = this.previous_A.slice(0, -1);
            if (value == "+") {
              this.value_A = "%2B";
              this.previous_A = this.previous_A + this.value_A;
            } else if (value == "x") {
              this.value_A = "*";
              this.previous_A = this.previous_A + this.value_A;
            } else {
              this.previous_A = this.previous_A + value;
            }
          }
          if (this.new_A[1] == "x") {
            this.previous_A = this.previous_A.slice(0, -1);
            if (value == "+") {
              this.value_A = "%2B";
              this.previous_A = this.previous_A + this.value_A;
            } else if (value == "x") {
              this.value_A = "*";
              this.previous_A = this.previous_A + this.value_A;
            } else {
              this.previous_A = this.previous_A + value;
            }
          }
          if (this.new_A[1] == ".") {
            this.previous_A = this.previous_A.slice(0, -1);
            if (value == ".") {
              this.previous_A = this.previous_A + value;
            }
          }
        } else {
          if (value == "+") {
            this.value_A = "%2B";
            this.previous_A = this.previous_A + this.value_A;
          } else if (value == "x") {
            this.value_A = "*";
            this.previous_A = this.previous_A + this.value_A;
          } else {
            this.previous_A = this.previous_A + value;
          }
          this.previousScreenText_A = this.previousScreenText_A + value;
        }
      }
      this.new_A = this.previousScreenText_A.split(
        this.previousScreenText_A.slice(0, -1)
      );
    },
    clear_A() {
      this.currentScreenText_A = "0";
      this.previousScreenText_A = "0";
      this.value_A = "";
      this.previous_A = "";
      this.new_A = "";
    },
    computation_A() {
      axios
        .get("https://api.mathjs.org/v4/?expr=" + this.previous_A)
        .then((res) => {
          this.current_A = res.data;
          this.currentScreenText_A = this.current_A;
          this.arrA = {};
          this.arrA = {
            name: "Calculator A",
            result: this.currentScreenText_A,
            previousScreen: this.previousScreenText_A,
            date:
              this.date.getDate().toString() +
              "/" +
              this.date.getMonth().toString() +
              "/" +
              this.date.getFullYear().toString() +
              "-" +
              this.date.getHours().toString() +
              ":" +
              this.date.getMinutes().toString() +
              "." +
              this.date.getSeconds().toString(),
          };

          this.setData(this.arrA);
        })
        .catch((error) => {
          console.error(error);
        });
    },
    // -------------------------------  Method Calculator B --------------------------------------------
    calculator_B(value) {
      if (this.previousScreenText_B == "0") {
        if (value == ".") {
          this.previousScreenText_B += value;
          this.previous_B = "0" + value;
        } else {
          this.previousScreenText_B = value;
          this.previous_B = value;
        }
      } else {
        if (
          (this.new_B[1] == "+" ||
            this.new_B[1] == "-" ||
            this.new_B[1] == "x" ||
            this.new_B[1] == ".") &&
          (value == "+" || value == "-" || value == "x" || value == ".")
        ) {
          this.previousScreenText_B =
            this.previousScreenText_B.slice(0, -1) + value;
          if (this.new_B[1] == "+") {
            this.previous_B = this.previous_B.slice(0, -3);
            if (value == "+") {
              this.value_B = "%2B";
              this.previous_B = this.previous_B + this.value_B;
            } else if (value == "x") {
              this.value_B = "*";
              this.previous_B = this.previous_B + this.value_B;
            } else {
              this.previous_B = this.previous_B + value;
            }
          }
          if (this.new_B[1] == "-") {
            this.previous_B = this.previous_B.slice(0, -1);
            if (value == "+") {
              this.value_B = "%2B";
              this.previous_B = this.previous_B + this.value_B;
            } else if (value == "x") {
              this.value_B = "*";
              this.previous_B = this.previous_B + this.value_B;
            } else {
              this.previous_B = this.previous_B + value;
            }
          }
          if (this.new_B[1] == "x") {
            this.previous_B = this.previous_B.slice(0, -1);
            if (value == "+") {
              this.value_B = "%2B";
              this.previous_B = this.previous_B + this.value_B;
            } else if (value == "x") {
              this.value_B = "*";
              this.previous_B = this.previous_B + this.value_B;
            } else {
              this.previous_B = this.previous_B + value;
            }
          }
          if (this.new_B[1] == ".") {
            this.previous_B = this.previous_B.slice(0, -1);
            if (value == ".") {
              this.previous_B = this.previous_B + value;
            }
          }
        } else {
          if (value == "+") {
            this.value_B = "%2B";
            this.previous_B = this.previous_B + this.value_B;
          } else if (value == "x") {
            this.value_B = "*";
            this.previous_B = this.previous_B + this.value_B;
          } else {
            this.previous_B = this.previous_B + value;
          }
          this.previousScreenText_B = this.previousScreenText_B + value;
        }
      }
      this.new_B = this.previousScreenText_B.split(
        this.previousScreenText_B.slice(0, -1)
      );
    },
    clear_B() {
      this.currentScreenText_B = "0";
      this.previousScreenText_B = "0";
      this.value_B = "";
      this.previous_B = "";
      this.new_B = "";
    },
    computation_B() {
      axios
        .get("https://api.mathjs.org/v4/?expr=" + this.previous_B)
        .then((res) => {
          this.current_B = res.data;
          this.currentScreenText_B = this.current_B;
          this.arrB = {};
          this.arrB = {
            name: "Calculator B",
            result: this.currentScreenText_B,
            previousScreen: this.previousScreenText_B,
            date:
              this.date.getDate().toString() +
              "/" +
              this.date.getMonth().toString() +
              "/" +
              this.date.getFullYear().toString() +
              "-" +
              this.date.getHours().toString() +
              ":" +
              this.date.getMinutes().toString() +
              "." +
              this.date.getSeconds().toString(),
          };

          this.setData(this.arrB);
        })
        .catch((error) => {
          console.error(error);
        });
    },
    // -------------------------------  Method History --------------------------------------------
    setData(data) {
      this.allHistory.push(data);
      localStorage.setItem("historyList", JSON.stringify(this.allHistory));
      this.hisResult = JSON.parse(localStorage.getItem("historyList"));
      // console.log(this.hisResult);
    },
    clear_history() {
      if (confirm("Do you want to clear all history?")) {
        localStorage.clear();
        this.allHistory = [];
        this.hisResult = [];
      }
    },
    onChange(event) {
      this.selectCal = event.target.value;
      console.log("Change to " + this.selectCal);
    },
  },
};
</script>

<style>
/* ----------------------------------- nav bar ----------------------------------------------------- */
.nav {
  background-color: white;
}
.headerNav {
  font-size: 1.3rem;
  margin-left: 20px;
  color: #797d7f;
}
.navbar {
  box-shadow: 0 2px 4px -1px rgba(0, 0, 0, 0.25);
}
/* ---------------------------------- calculator -------------------------------------------------- */
.header {
  font-size: 1.3rem;
  margin-left: 30px;
  color: #797d7f;
}

.card {
  width: 90%;
  height: 140%;
  margin-left: 30px;
  border-radius: 20px;
}
button {
  border-style: solid;
  font-size: larger;
  font-weight: 600;
  margin-top: 5px;
  padding: 12px 20px;
  border-radius: 12px;
  background-color: #a7d4fa;
  border-color: #aed6f1;
  color: #626567;
}
.current {
  color: #797d7f;
  margin-top: 25px;
  margin-bottom: -10px;
  margin-left: 16px;
}
hr {
  margin-left: 16px;
  width: 235px;
}
.previous {
  color: #909497;
  margin-left: 16px;
  margin-top: -15px;
  font-weight: 400;
}
.btPlus {
  padding: 43px 20px;
}
.btEqual {
  padding: 74px 20px;
}
.bt0 {
  padding: 12px 50px;
}
.btPoint {
  padding: 12px 22px;
}
.btMinus {
  padding: 12px 21px;
}
.btX {
  padding: 12px 21px;
}
.btC {
  padding: 12px 19px;
}
.r1,
.r2 {
  margin-left: 6px;
}
.c1,
.c2,
.c3,
.c4,
.c5,
.c6,
.c7,
.c8 {
  margin-left: 10px;
}
.btC:hover {
  background-color: #d6eaf8;
}
.btX:hover {
  background-color: #d6eaf8;
}
.btMinus:hover {
  background-color: #d6eaf8;
}
.btPlus:hover {
  background-color: #d6eaf8;
}
.btEqual:hover {
  background-color: #d6eaf8;
}
.btPoint:hover {
  background-color: #d6eaf8;
}
.bt0:hover {
  background-color: #d6eaf8;
}
.bt1:hover {
  background-color: #d6eaf8;
}
.bt2:hover {
  background-color: #d6eaf8;
}
.bt3:hover {
  background-color: #d6eaf8;
}
.bt4:hover {
  background-color: #d6eaf8;
}
.bt5:hover {
  background-color: #d6eaf8;
}
.bt6:hover {
  background-color: #d6eaf8;
}
.bt7:hover {
  background-color: #d6eaf8;
}
.bt8:hover {
  background-color: #d6eaf8;
}
.bt9:hover {
  background-color: #d6eaf8;
}

.btC:active {
  background-color: #85c1e9;
}
.btX:active {
  background-color: #85c1e9;
}
.btMinus:active {
  background-color: #85c1e9;
}
.btPlus:active {
  background-color: #85c1e9;
}
.btEqual:active {
  background-color: #85c1e9;
}
.btPoint:active {
  background-color: #85c1e9;
}
.bt0:active {
  background-color: #85c1e9;
}
.bt1:active {
  background-color: #85c1e9;
}
.bt2:active {
  background-color: #85c1e9;
}
.bt3:active {
  background-color: #85c1e9;
}
.bt4:active {
  background-color: #85c1e9;
}
.bt5:active {
  background-color: #85c1e9;
}
.bt6:active {
  background-color: #85c1e9;
}
.bt7:active {
  background-color: #85c1e9;
}
.bt8:active {
  background-color: #85c1e9;
}
.bt9:active {
  background-color: #85c1e9;
}

/* ----------------------------------------- history ----------------------------------------------- */
.headerHis {
  font-size: 1.3rem;
  margin-left: 30px;
  color: #797d7f;
}

.cardHis {
  width: 95%;
  height: 150%;
  margin-left: 30px;
  border-radius: 20px;
  overflow: auto;
}
input {
  width: 100%;
}
.select1 {
  height: 35px;
  margin-left: 10%;
  border-radius: 13px;
  border-width: thin;
  box-shadow: 0 2px 4px -1px rgba(0, 0, 0, 0.25);
}
.select2 {
  height: 35px;
  margin-left: 10%;
  border-radius: 13px;
  border-width: thin;
  box-shadow: 0 2px 4px -1px rgba(0, 0, 0, 0.25);
}
.calName {
  font-size: 1.3rem;
  margin-left: 15px;
  color: #797d7f;
}
.hisLine {
  margin-left: 16px;
  width: 375px;
}
.hisCurrent {
  color: #797d7f;
  margin-top: unset;
  margin-bottom: -10px;
  margin-left: 16px;
}
.hisDate {
  color: #aed6f1;
  /* margin-left: 16px; */
  /* margin-top: -15px; */
  font-weight: 400;
}
.hisClear {
  border-radius: 13px;
  background-color: #f1948a;
  border-color: #f1948a;
  color: white;
  font-size: x-large;
  padding: 3px 10px;
  margin-right: 20px;
  margin-bottom: 20px;
  position: fixed;
  bottom: 0px;
  right: 40px;
}
.red {
  color: #ec7063;
}
</style>
